/*
 * UbtCollectionProjectPlugin.java
 *
 * Created on 18. November 2003, 16:15
 */

package net.metadiversity.diversity.navigator.projectPlugin;

import org.apache.log4j.Logger;

//import net.metadiversity.diversity.navigator.gui.ProjectQueryPanel;
import net.metadiversity.diversity.navigator.gui.delta_editor.DeltaEditor;
import net.metadiversity.diversity.navikey.ui.NaviKey;

/**
 *
 * @author  Dieter Neubacher
 */
public class DeemyProjectPlugin extends Plugin
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3256446897664570418L;
    static Logger logger = Logger.getLogger( DeemyProjectPlugin.class.getName() );
    
    /** Creates a new instance of UbtCollectionProjectPlugin */
    public DeemyProjectPlugin()
    {
        super( "DEEMY", "Diversity Workbench" );

        // Add project databases
        
        String delta_editor_database = "DEEMY Descriptions";
        addProjectDatabase( null, delta_editor_database );
        
        String diversity_taxon_names_database = "Diversity Taxon Names Fungi";
        addProjectDatabase( null, diversity_taxon_names_database );
        
        java.sql.Connection namesConnection = null;        
        java.sql.Connection con = null;
        
        try
        {
            net.metadiversity.diversity.navigator.connection.ConnectionInfo ci;        
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( delta_editor_database );
            logger.info( "Connect to: " + ci.getUrl() );
            con = ci.getConnection();
            
            ci = net.metadiversity.diversity.navigator.connection.ConnectionsManager.getConnectionInfoByName( diversity_taxon_names_database );
            logger.info( "Connect to: " + ci.getUrl() );
            namesConnection = ci.getConnection();
            
        }
        catch( java.sql.SQLException ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        catch( Exception ex )
        {
             logger.error( ex.getMessage(), ex.fillInStackTrace() );
        }
        String tablePrefix = "Deemy";

        logger.info( "init DeltaEditor" );
        DeltaEditor p = new DeltaEditor( con,  namesConnection, tablePrefix, true );
        
        logger.info( "init data for Navikey" );
        String specs = p.getSpecsString();
        String chars = p.getCharsString();
        String items = p.getItemsString();
        
        logger.info( "init Navikey" );
        NaviKey navikey = new NaviKey( (java.awt.Container) getIdentificationPanel(), specs, chars, items );
        navikey.init();
        
        this.setGridViewPanel( p );
        this.pack();
        this.setVisible( true );
    }
}
