package net.metadiversity.diversity.navikey.delta;
/*
 *
 */

import java.io.BufferedReader;

import java.net.URL;

import net.metadiversity.diversity.navikey.bo.Delta;
import net.metadiversity.diversity.navikey.bo.DeltaInterface;

public class LocalDeltaConnector extends DeltaConnector
{
    Delta delta;
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public LocalDeltaConnector()
    {
        delta = new Delta();
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public LocalDeltaConnector(String baseUrl, String specs, String chars, String items)
    {
        this();
        try
        {
            BufferedReader specReader;
            BufferedReader charReader;
            BufferedReader itemReader;
            
            System.out.println( "NaviKey: base URL: " + baseUrl );
            
            // DIDI: 2005.09.26
            // JAVA 1.4: can't load the file "file://..." 
            // ERROR sun.net.ftp.FtpLoginException: Not logged in
            
            boolean useUrlFlag = ! baseUrl.startsWith( "file" );                
            
            if( useUrlFlag )
            {

                URL specUrl = new URL(baseUrl + specs);
                System.out.println( "load: " + specUrl );
                specReader = new BufferedReader( new java.io.InputStreamReader( specUrl.openStream() ) );            
                URL charUrl = new URL(baseUrl + chars);
                System.out.println( "load: " + charUrl );
                charReader = new BufferedReader( new java.io.InputStreamReader( charUrl.openStream() ) );            
                URL itemUrl = new URL(baseUrl + items);
                System.out.println( "load: " + itemUrl );
                itemReader = new BufferedReader( new java.io.InputStreamReader( itemUrl.openStream() ) );            
            }
            else
            {
                String filename;
                filename = baseUrl + specs;
                filename = filename.substring( filename.indexOf( ":/") + 2 );
                specReader = new BufferedReader( new java.io.InputStreamReader( new java.io.FileInputStream( filename )  ) );            
                filename = baseUrl + chars;
                filename = filename.substring( filename.indexOf( ":/") + 2 );
                charReader = new BufferedReader( new java.io.InputStreamReader( new java.io.FileInputStream( filename )  ) );            
                filename = baseUrl + items;
                filename = filename.substring( filename.indexOf( ":/") + 2 );
                itemReader = new BufferedReader( new java.io.InputStreamReader( new java.io.FileInputStream( filename )  ) );            
            }
            
            Delta.setPersistentPeer( new DeltaFilePeer( specReader, charReader, itemReader ) );
            
            delta.restore();
        }
        catch(Exception e)
        {
            System.out.println( "Error dealing with files.\n" );
            e.printStackTrace();
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public DeltaInterface getObject()
    {
        return delta;
    }
    
}
