/**
 * InfoFrame.java
 *  Displays information about the current version of NaviKey
 * @author Michael Bartley
 * @date 7/1/99
 * @author Dieter Neubacher
 */

package net.metadiversity.diversity.navikey.ui;

public class InfoFrame extends javax.swing.JFrame
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3258409547327419444L;
    private javax.swing.JButton closebutton;
    
    public InfoFrame()
    {
        super( "About NaviKey v4.0" );
        
        getContentPane().setLayout( new java.awt.BorderLayout() );
        
        closebutton = new javax.swing.JButton( "Close" );
        closebutton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                closeButtonActionPerformed( evt );
            }
        });
        
        getContentPane().add( java.awt.BorderLayout.SOUTH, closebutton );
        
        String info = "<html><b><h1>NaviKey v. 4.0</h1></b> " +
                      "(<a href=\"http://www.gnu.org/licenses/licenses.html\">" + 
                      "GNU General Public Licence<a>)<p>2005-10-25<p>" + 
                      "This software is based on an earlier version (NaviKey v. 2.3 by Michael Bartley and Noel Cross, Harvard University Herbarium, Boston, USA) and has been further developed in the frame of the " +
                        "<a href=\"http://www.biota-africa.de/\">" + 
                      "BIOTA Africa project</a> by Dieter Neubacher and Gerhard Rambold (University of Bayreuth, Germany). Email any comments about the program to navikey@uni-bayreuth.de (enabled from January 1st, 2006)." + 
                      
                      "<p>NaviKey v. 4.0 is a tool for querying descriptive data and has been implemented as" +
                      "<ul>" + 
                      "<li>a Java applet providing the contents of " +
                        "<a href=\"http://www.delta-intkey.com\">DELTA</a> flat files;" + 
                      "<li>a stand-alone Java application for accessing " +
                        "<a href=\"http://www.delta-intkey.com\">DELTA</a> flat files or " +
                        "<a href=\"http://www.diversitycampus.net/Workbench/download.html\">" +
                        "<i>DiversityDescription</i></a> PostgreSQL databases, respectively;" +
                      "<li>a module (\"plug-in\") of the " +
                        "<a href=\"http://141.84.65.156/DiversityNavigator/\">" +
                        "<i>Diversity Navigator</i></a> Java database client for accessing " +
                        "<a href=\"http://www.delta-intkey.com\">DELTA</a> flat files or " +
                        "<a href=\"http://www.diversitycampus.net/Workbench/download.html\">" +
                        "<i>DiversityDescription</i></a> PostgreSQL databases, respectively." +
                      "</ul>" +
                      "Regular version updates of the NaviKey applet and stand-alone NaviKey application are provided on the " +
                        "<a href=\"http://141.84.65.156/NaviKey/\">NaviKey Download Page</a> (http://141.84.65.156/NaviKey/)" +
                      "<p>" +    
                      "The user interface contains four main panels:" +
                      "<ul>" + 
                      "<li>top left - Character panel: selection of the characters;" + 
                      "<li>top right - Character states or numeric data panel: preselection of states of the selected character (to finalize the query, the &lt;Select&gt; button is to be used);" + 
                      "<li>bottom left - Query criteria panel: display of previous character state selections;" + 
                      "<li>bottom right - Matching items panel: display of matching items (selecting any item will bring up a complete description of that item).</ul>" + 
                      "<p>NaviKey checkbox matching options are:<ul>" + 
                      "<li><b>Use \"Best\" algorithm</b><br>To be implemented.</li>" + 
                      "<li><b>Use character dependencies</b><br>To be implemented.</li>" +
                      "<li><b>Restrict view on used characters and character states of remaining items</b>" +
                       "<br>When checked, NaviKey only displays those characters and states (in the two top main panels) that will reduce the number of item matches; characters or states which are not applicable to the remaining items (in the bottom right main panel) or apply to all of the items in the same form are no longer displayed. If a character is selected for which more than one state applies, multiple state selection may be performed using the &lt;Ctrl&gt; (or corresponding) button (see also \"Enable multiple selection of character states\"). " +
                       "In the case of numeric characters, the top right panel provides fields for input of numeric values. After inputing either a single measurement or a range of values, the selection of the &lt;Add&gt; button will finalize the query.</li>" +
                      "<li><b>Exclude items with undefined states in selected characters</b>" +
                       "<br>When checked, NaviKey only displays (in the bottom right panel) those items for which the selected character(s) is(are) specified in the database and excludes all items with at least one of the selected characters being not specified. This behaviour largely corresponds with the \"analysis/data retrieval mode\" in CSIRO-Delta-Intkey and the <i>DiversityDescription</i>-Identify; unchecking the box enables the \"Direct identification\" mode with the undefined states included.</li>" +
                      "<li><b>Enable multiple selection of character states (with OR)</b>" +
                       "<br>When checked, NaviKey selects those items matching by at least one character state of the selected characters. The selected mode of this option applies to all states within the selected characters.</li><li><b>Use extreme interval validation</b><br>When checked, the whole range between the extreme values (if present in the item data set) is used in numerical queries, otherwise only the range between minimum and maximum values (if present in the item data set) is considered.</li>" +
                      "<li><b>Use overlapping interval validation</b>" +
                       "<br>When checked, overlapping between queried and the specified numerical intervals is matching, otherwise not.</li></ul>" +
                      "</html>";  
        
        javax.swing.JEditorPane ta;
        ta = new javax.swing.JEditorPane( "text/html", info );
        ta.setEditable( false );
        ta.setMargin( new java.awt.Insets( 10,10,10,10) );
        ta.setCaretPosition( 0 ); // Moveto first Position
        javax.swing.JScrollPane sp = new javax.swing.JScrollPane( ta );
        sp.setHorizontalScrollBarPolicy( javax.swing.JScrollPane.HORIZONTAL_SCROLLBAR_NEVER );
        getContentPane().add( java.awt.BorderLayout.CENTER, sp );
    }
    
    private void closeButtonActionPerformed( java.awt.event.ActionEvent evt )
    {
        setVisible( false );
        dispose();
    }
}
