package net.metadiversity.diversity.navikey.ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.io.BufferedReader;
import java.net.URL;

import net.metadiversity.diversity.navikey.bo.DeltaInterface;
import net.metadiversity.diversity.navikey.bo.Resource;
import net.metadiversity.diversity.navikey.delta.DeltaConnector;
import net.metadiversity.diversity.navikey.delta.LocalDeltaConnector;
import net.metadiversity.diversity.navikey.delta.DnDatabaseConnector;
import net.metadiversity.diversity.navikey.servlet.HttpDeltaConnector;
//import net.metadiversity.diversity.navikey.resource.IconPanel;

/**
 *
 * NaviKey.java
 *
 * @author Michael Bartley
 * 3/25/98
 * @author Dieter Neubacher
 */

public class NaviKey extends javax.swing.JPanel
{
    /**
     * Comment for <code>serialVersionUID</code>
     */
    private static final long serialVersionUID = 3762532317360829234L;
    //public static String imageLocation;
    SuperPanel          superPanel;
    ConfigurationPanel  cp;
    javax.swing.JLabel  navikeyIcon = null;    
    DeltaInterface      delta;
    
    //These will be adjusted by user, and used by all subpanels as selections
    static Color naviKeyBackgroundColor = Color.black;
    static Color itemCharacterColor     = Color.cyan;
    static Color itemStateColor         = Color.magenta;
    static Color itemSelectionsColor    = Color.green;
    static Color itemListColor          = Color.yellow;
    static Color buttonColor            = Color.pink;
    static Color boxBGColor             = Color.white;
    static Color boxFGColor             = Color.black;
    static Color itemDisplayColor       = Color.cyan;
    static Color itemDisplayTextColor   = Color.white;
    static Color itemDisplayBGColor     = Color.darkGray;
    static Color itemDisplayFGColor     = Color.green;
    static Color imageBGColor           = Color.black;
    static Color imageFGColor           = Color.white;
    
    private boolean standAlone;
    // DiversityNavigator
    private boolean useDnDatabaseConnector = false;
    private String specsString = null;
    private String charsString = null;
    private String itemsString = null;
    
    private String specsfile = null;
    private String charsfile = null;
    private String itemsfile = null;
    private String imageDirectory=null;
    //
    // Options
    //
    private static boolean intelligence          = false;
    private static boolean excludeUndefined      = false;
    private static boolean multipleSelectionOR   = true;
    private static boolean extremeInterval       = true;
    private static boolean overlappingInterval   = true;
    
    public static boolean removeCommentFlag = false; // DEEMY ???
    
    private String servletURL=null;
    
    private java.lang.String        propertyFileName = null;
    private java.net.URL            codebase         = null;
    private java.awt.Container      contentPane      = null;
    
    private void initializeParameters()
    {
        BufferedReader bufferdReader = null;
        String props = null;
        try
        {
            if( ! useDnDatabaseConnector )
            {
                props = getParameter( "propsfile" );
                URL url = new URL( getCodeBase().toString() + props ); 
                
                // JAVA 1.4: can't load the file "file://..." 
                // ERROR sun.net.ftp.FtpLoginException: Not logged in                
            
            
                System.out.println( "URL: " + url );
                System.out.println( "Protocol: " + url.getProtocol() );
                
                boolean useUrlFlag = ! url.getProtocol().equalsIgnoreCase( "FILE" );
                
                if( useUrlFlag )
                {                                    
                    bufferdReader = new BufferedReader( new java.io.InputStreamReader( url.openStream() ) );
                }
                else
                {
                    String filename = getCodeBase().toString() + props;
                    filename = filename.substring( filename.indexOf( ":/") + 2 );
                    bufferdReader = new BufferedReader( new java.io.InputStreamReader( new java.io.FileInputStream( filename ) ) );
                }
            }
        }
        catch( Exception e )
        {            
            System.out.println( "Can't read propsfile: " + getCodeBase().toString() + props );
            System.out.println( "NaviKey: No color scheme specified, using defaults" );
            standAlone = true;  // Run as Application
            return;
        }
        
        String line     = "";
        String value    = "";
        Color colorSelect = null;
        String field    = "";
        
        while( line != null )
        {
            try
            {
                line = bufferdReader.readLine();
                while( line != null )
                {
                    colorSelect = null;
                    if( line.indexOf( '=' ) > 0 )
                    {
                        field = line.substring( 0,line.indexOf( '=' ) );
                        value = line.substring( line.indexOf( '=' ) + 1 );
                        
                        if( field.equals( "standalone" ) )
                        {
                            if( value.equals( "false" ) )
                            {
                                System.out.println( "Good luck, servlet" );
                                standAlone = false;
                            }
                            else
                            {
                                System.out.println( "Using da files" + field + value );
                                standAlone = true;
                            }
                        }
                        // DEEMY: 2005-10-15 Remove comments                        
                        if( field.equals( "removeCharacterStateCommentes" ) )
                        {
                            if( value.equals( "false" ) )
                            {
                                removeCommentFlag = false;
                            }
                            else
                            {
                                removeCommentFlag = true;
                            }
                        }
                        //
                        else if( field.equals( "servletURL" ) )
                        {
                            servletURL = value;
                        }
                        
                        else if( field.equals( "specsfile" ) )
                            specsfile = value;
                        else if( field.equals( "charsfile" ) )
                            charsfile = value;
                        else if( field.equals( "itemsfile" ) )
                            itemsfile = value;
                        else if( field.equals( "imageDirectory" ) )
                            imageDirectory = value;
                        
                        else
                        {
                            if ( value.equals( "black" ) )
                                colorSelect = Color.black;
                            else if ( value.equals( "blue" ) )
                                colorSelect = Color.blue;
                            else if ( value.equals( "cyan" ) )
                                colorSelect = Color.cyan;
                            else if ( value.equals( "darkGray" ) )
                                colorSelect = Color.darkGray;
                            else if ( value.equals( "gray" ) )
                                colorSelect = Color.gray;
                            else if ( value.equals( "green" ) )
                                colorSelect = Color.green;
                            else if ( value.equals( "lightGray" ) )
                                colorSelect = Color.lightGray;
                            else if ( value.equals( "magenta" ) )
                                colorSelect = Color.magenta;
                            else if ( value.equals( "orange" ) )
                                colorSelect = Color.orange;
                            else if ( value.equals( "pink" ) )
                                colorSelect = Color.pink;
                            else if ( value.equals( "red" ) )
                                colorSelect = Color.red;
                            else if ( value.equals( "white" ) )
                                colorSelect = Color.white;
                            else if ( value.equals( "yellow" ) )
                                colorSelect = Color.yellow;
                            
                            if( colorSelect != null )
                            {
                                if( field.equals( "naviKeyBackgroundColor" ) )
                                    naviKeyBackgroundColor = colorSelect;
                                else if ( field.equals( "itemCharacterColor" ) )
                                    itemCharacterColor = colorSelect;
                                else if ( field.equals( "itemSelectionsColor" ) )
                                    itemSelectionsColor = colorSelect;
                                else if ( field.equals( "itemListColor" ) )
                                    itemListColor = colorSelect;
                                else if ( field.equals( "buttonColor" ) )
                                    buttonColor = colorSelect;
                                else if ( field.equals( "boxBGColor" ) )
                                    boxBGColor = colorSelect;
                                else if ( field.equals( "boxFGColor" ) )
                                    boxFGColor = colorSelect;
                                else if ( field.equals( "itemDisplayColor" ) )
                                    itemDisplayColor = colorSelect;
                                else if ( field.equals( "itemDisplayTextColor" ) )
                                    itemDisplayTextColor = colorSelect;
                                else if ( field.equals( "itemDisplayBGColor" ) )
                                    itemDisplayBGColor = colorSelect;
                                else if ( field.equals( "itemDisplayFGColor" ) )
                                    itemDisplayFGColor = colorSelect;
                                else if ( field.equals( "imageBGColor" ) )
                                    imageBGColor = colorSelect;
                                else if ( field.equals( "imageFGColor" ) )
                                    imageFGColor = colorSelect;
                            }
                        }
                    }
                    line = bufferdReader.readLine();
                }
                bufferdReader.close();
            }
            catch( Exception e )
            {
                System.out.println( "Some error in reading file, using defaults" );
                return;
            }
            System.out.println( line );
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /**
     * NaviKey ( Plugin for DiversityNavigator )
     */
    public NaviKey( java.awt.Container contentPane, String specsString, String charsString, String itemsString )
    {   
        this.specsString = specsString;
        this.charsString = charsString;
        this.itemsString = itemsString;
        useDnDatabaseConnector = true;
        propertyFileName = null;
        this.contentPane = contentPane;
        this.codebase = null;
    }
    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    public NaviKey( java.awt.Container contentPane, String propsfile, URL codebase )
    {
        propertyFileName = propsfile;
        this.codebase    = codebase;
        this.contentPane = contentPane;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private URL getCodeBase()
    {
        System.out.println( "getCodeBase() : " + codebase );
        return codebase;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    String getParameter( String str )
    {
        System.out.println( "getParam( " + str +" )" );
        if( str.equals( "propsfile" ) )
        {
            return propertyFileName;
        }
        else
        {
            return null;
        }
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    java.awt.Container getContentPane()
    {
        // System.out.println( "getContentPane() : " + contentPane );
        return contentPane;
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------    
    public void init()
    {
        getContentPane().setLayout( new BorderLayout() );
        initializeParameters();
        DeltaConnector dc;
        
        System.out.println( "init()" );
        
        if( imageDirectory != null )
        {
            try
            {
                Resource.defaultLocation = getCodeBase().toString() + imageDirectory +"/";
            }
            catch( Exception e )
            {
                System.out.println( "NaviKey: Unable to get code base. "+e );
            }
        }
        if( useDnDatabaseConnector )
        {
            dc = runDnDatabaseConnector();
        }
        else if( standAlone )
        {
            dc = runStandAlone();
        }
        else
        {
            dc = runHttpConnector();
        }
        delta = dc.getObject();
        superPanel = new SuperPanel( delta );
        // Item Character Panel
        System.out.println( "Setting panels" );
        superPanel.itemCharacterPanel.setItemCharacters( delta.getItemCharacterList( null, false ) );
        superPanel.itemCharacterPanel.updateList();
        // Item Panel
        superPanel.itemsPanel.setItems( delta.getItemList( null ) );
        superPanel.itemsPanel.updateList();
        
        System.out.println( "Composing all" );
        superPanel.build();
        // State Panel
        (( java.awt.CardLayout )superPanel.statePanel.getLayout()).first( superPanel.statePanel );        
        superPanel.setSize( new java.awt.Dimension( 400, 640 ) );
        
        System.out.println( "setting layouts" );
        // Configuration Panel
        cp = new ConfigurationPanel();
        cp.addNavikeyGuiListener( superPanel.getNavikeyGuiListener( "Options" ) );

        getContentPane().add( java.awt.BorderLayout.SOUTH, cp );
        // 
        getContentPane().add( java.awt.BorderLayout.CENTER, superPanel );
        // setup Navikey icon
        try
        {
            navikeyIcon = new javax.swing.JLabel( new javax.swing.ImageIcon( new java.net.URL( getCodeBase() + "images/nlogo.gif" ) ) );
            getContentPane().add( java.awt.BorderLayout.NORTH, navikeyIcon );
        }        
        catch( java.net.MalformedURLException ex )
        {
            System.out.println( "NaviKey: image file not available" + ex );
        }
        
        this.setVisible( true );
        System.out.println( "NaviKey: Done with init" );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private LocalDeltaConnector runStandAlone()
    {
        if( specsfile == null || charsfile == null || itemsfile == null )
        {
            System.out.println( "NaviKey: Required files not specified." );
            System.out.println( "NaviKey: use default filenames: chars, specs, items." );

            specsfile = "specs";
            charsfile = "chars";
            itemsfile = "items";
            // System.exit( 0 );
        }
        try
        {
            URL base = getCodeBase();
            String url = base.toString();
            System.out.println( "Printme " );
            return new LocalDeltaConnector( url, specsfile, charsfile, itemsfile );
        }
        catch( Exception e )
        {
            System.out.println( "NaviKey: Error reading delta files.\n" +e );
            System.exit( 0 );
            return new LocalDeltaConnector();
        }
    }    
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private HttpDeltaConnector runHttpConnector()
    {
        //return new HttpDeltaConnector( "url goes here" );
        return new HttpDeltaConnector( servletURL );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    private DnDatabaseConnector runDnDatabaseConnector()
    {
        return new DnDatabaseConnector( specsString, charsString, itemsString );
    }
    //--------------------------------------------------------------------------
    //--------------------------------------------------------------------------
    /*
    public void unused_start()
    {
        System.out.println( superPanel.getBounds() );
        
        cp.reshape( cp.getBounds().x, superPanel.getBounds().height, getBounds().width, 35 );
        cp.setBackground( naviKeyBackgroundColor );
        if( naviKeyBackgroundColor.equals( Color.black ) )
        {
            cp.setForeground( Color.white );
        }
        else
        {
            cp.setForeground( Color.black );
        }
        System.out.println( superPanel.getBounds() );
        repaint();
    } 
     */       
    /**
     * @return Returns the excludeUndefined.
     */
    public static boolean isExcludeUndefined()
    {
        return excludeUndefined;
    }
    /**
     * @param excludeUndefined The excludeUndefined to set.
     */
    public static void setExcludeUndefined( boolean excludeUndefined )
    {
        NaviKey.excludeUndefined = excludeUndefined;
    }
    /**
     * @return Returns the extremeInterval.
     */
    public static boolean isExtremeInterval()
    {
        return extremeInterval;
    }
    /**
     * @param extremeInterval The extremeInterval to set.
     */
    public static void setExtremeInterval( boolean extremeInterval )
    {
        NaviKey.extremeInterval = extremeInterval;
    }
    /**
     * @return Returns the intelligence.
     */
    public static boolean isIntelligence()
    {
        return intelligence;
    }
    /**
     * @param intelligence The intelligence to set.
     */
    public static void setIntelligence( boolean intelligence )
    {
        NaviKey.intelligence = intelligence;
    }
    /**
     * @return Returns the multipleSelectionOR.
     */
    public static boolean isMultipleSelectionOR()
    {
        return multipleSelectionOR;
    }
    /**
     * @param multipleSelectionOR The multipleSelectionOR to set.
     */
    public static void setMultipleSelectionOR( boolean multipleSelectionOR )
    {
        NaviKey.multipleSelectionOR = multipleSelectionOR;
    }
    /**
     * @return Returns the overlappingInterval.
     */
    public static boolean isOverlappingInterval()
    {
        return overlappingInterval;
    }
    /**
     * @param overlappingInterval The overlappingInterval to set.
     */
    public static void setOverlappingInterval( boolean overlappingInterval )
    {
        NaviKey.overlappingInterval = overlappingInterval;
    }
}
